routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth/login');
});

Route::group(['middleware' => ['auth']], function () {
    Route::resource('/post', 'PostController');
    Route::resource('/tag', 'TagController');

    Route::get('/home', 'HomeController@index')->name('home');
    // Route::get('/profil', '');

    Route::delete('/post/{post_id}', 'PostController@destroy');
});
// Route::group(['middleware' =>['auth']], function(){
//     Route::resource('/post', 'PostController');
//     // Route::resource('/tag', 'TagController');

//     Route::get('/home', 'HomeController@index')->name('home');
// // Route::get('/profil', '');

//     // Route::delete('/post/{post}', 'PostController@destroy');

// });

// Route::get('/post', 'PostController@index');
// Route::get('/post/create', 'PostController@create');
// Route::post('/post', 'PostController@store');
// Route::get('/post/{post_id}', 'PostController@show');
// Route::get('/post/{post_id}/edit', 'PostController@edit');
// Route::put('/post/{post_id}', 'PostController@update');
// Route::delete('/post/{post_id}', 'PostController@destroy');

Route::resource('/post', 'PostController');
Route::resource('/profile', 'ProfileController');
Route::resource('/editc', 'EditController');

// Show Posts By Tag
Route::get('/tag/{tag_id}', 'TagController@index');


Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
// Route::get('/lgn/{id}', 'LoginController@index');
// Route::get('/profil', '');


//edit password
Route::get('/edit', 'ProfileController@index')->name('edit.index');
Route::post('/editprofile', 'ProfileController@editprofile')->name('edit.editprofile');


// Route::

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $table = "posts";
    protected $guarded = [];

    public function tags() {
        return $this->belongsToMany('App\Tag', 'post_tag', 'post_id', 'tag_id');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Post;
use App\Tag;
use Alert;
use DB;

class PostController extends Controller
{
    // Middleware
    public function __construct()
    {
        $this->middleware('auth')->except('index', 'show');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $post = Post::all();
        $tag = Tag::all();
        return view('post.index', compact('post', 'tag'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('post.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title' => 'required|unique:posts'
        ]);

        // Mengubah request tags menjadi array dengan function explode
        $tags_arr = explode(', ', $request["tags"]);

        // Buat array penampung
        $tag_ids = [];

        /*
           Looping melakukan pengecekan apakah sudah ada tagnya atau belum
           jika sudah ambil id nya 
           jika belum, simpan tag lalu ambil id nya lalu ditampung diarray penampung
           gunakan fungsi dari eloquent 
        */
        foreach($tags_arr as $tag_name) {
            $tag = Tag::firstOrCreate(['name' => $tag_name]);
            $tag_ids[] = $tag->id;
        }


        $post = Post::create([
            "title" => $request["title"],
            "body" => $request["body"]
        ]);
        
        // Tampilkan Tags
        $post->tags()->sync($tag_ids);

        // Sweet Alert  
        if ($post) {
            toast('Data Berhasil Ditambahkan', 'success', 'top-right');
            return redirect('/post');
        } else {
            alert()->error('Pesan Error', 'Data Gagal Ditambahkan');
            return redirect('/post');
        }

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $post = Post::find($id);
        return view('post.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $post = Post::find($id);
        $tag = Tag::all();        

        return view('post.edit', compact('post', 'tag'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'title' => 'required',
            'body' => 'required',
        ]);

        // $tag_name = $request["tags"];

        $post = Post::find($id);
        $tags_arr = explode(', ', $request["tags"]);
        $tag_ids = [];

        foreach($tags_arr as $tag_name) {
            $tag = Tag::firstOrCreate(['name' => $tag_name]);
            $tag_ids[] = $tag->id;
        }

        $update = Post::where('id', $id)
            ->update([
                'title' => $request["title"],
                'body' => $request["body"],
            ]);

        $post->tags()->sync($tag_ids);

        if ($update) {
            toast('Data Berhasil Diupdate', 'success', 'top-right');
            return redirect('/post');
        } else {
            alert()->error('Pesan Error', 'Data Gagal Diupdate');
            return redirect('/post');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // $data = Post::destroy($id);
        $data = DB::table('post_tag')->where('post_id', $id)->delete();
        $data = DB::table('posts')->where('id', $id)->delete();
        if ($data) {
            toast('Data Berhasil Dihapus', 'success', 'top-right');
            return redirect('/post');
        } else {
            alert()->error('Pesan Error', 'Data Gagal Dihapus');
            return redirect('/post');
        }
        return redirect('/post');


        // $query = DB::table('tags')->where('id', $id)->delete();
        // return redirect('/post');
    }

    
}

resources/views/post/create.blade.php
@extends('layouts.master')

@section('title')
    Create Page
@endsection

@section('content')
<div class="card">
   <div class="card-header">
      <h2 class="card-title">Tambah Artikel</h2>
   </div>
   <div class="card-body">
      <form action="/post" method="POST">
         @csrf
         <div class="form-group">
            <label for="title">Judul</label>
            <input type="text" class="form-control" name="title" id="title" placeholder="Masukkan Judul" required>
            @error('title')
               <div class="alert alert-danger">
                  {{ $message }}
               </div>
            @enderror
         </div>
         <div class="form-group">
            <label for="body">Konten</label>
            <textarea class="form-control" style="height: 4cm" name="body" id="body" placeholder="Masukkan Konten" required></textarea>
            @error('body')
               <div class="alert alert-danger">
                  {{ $message }}
               </div>
               @enderror
         </div>

         <div class="form-group">
            <label for="tags">Tag</label>
            <input type="text" class="form-control" name="tags" id="tags" placeholder="format : tag1, tag2, tag3">
         </div>
         
         <button type="submit" class="btn btn-primary">Tambah</button>
      </form>
    </div>
 </div>

@endsection

resources/views/post/edit.blade.php
@extends('layouts.master')

@section('title')
    Edit Page
@endsection

@section('content')
    <div class="card">
        
        <div class="card-body">
            <form action="/post/{{$post->id}}" method="POST">
                @csrf
                @method('put')
                <div class="form-group">
                   <label for="title">Judul</label>
                   <input type="text" class="form-control" name="title" id="title" value="{{$post->title}}" placeholder="Masukkan Judul">
                   @error('title')
                      <div class="alert alert-danger">
                         {{ $message }}
                      </div>
                   @enderror
                </div>
                <div class="form-group">
                   <label for="body">Konten</label>
                     <textarea class="form-control" style="height: 4cm" name="body" id="body" placeholder="Masukkan Konten" required>{{$post->body}}</textarea>
                   @error('body')
                      <div class="alert alert-danger">
                         {{ $message }}
                      </div>
                   @enderror
                </div>
                <div class="form-group">
                  <label for="tags">Tag</label>
                  <input type="text" class="form-control" name="tags" id="tags" placeholder="format : tag1, tag2, tag3"
                  value="@forelse($post->tags as $tag){{$tag["name"]}}{{", "}}@empty @endforelse">
                  <h6 class="align: right">NB : Hapus koma paling belakang untuk tidak mengubah Tag</h6>
               </div>
                <button type="submit" class="btn btn-primary">Edit</button>
                <a href="{{route('post.index')}}" class="btn btn-danger">Back</a>
             </form>
        </div>
    </div>
@endsection

resources/views/post/index.blade.php
@extends('layouts.master')

@section('title')
    Index Page
@endsection

@section('content')
{{-- Post Table --}}
<div class="card">
    <div class="card-header">
        Tambah Artikel <a href="{{route('post.create')}}" class="btn btn-primary ml-2">Tambah</a>
    </div>
    
    <div class="card-body">
        @if(session('success'))
            <div class="alert alert-success">
                {{ session('success') }}
            </div>
        @endif
        <table class="table">
            <thead class="thead-light">
              <tr>
                <th style="width: 5%">No</th>
                <th style="width: 25%">Judul</th>
                <th style="width: 40%">Konten</th>
                <th style="width: 25%"><a>Action</a></th>
              </tr>
            </thead>
            <tbody>
                @forelse ($post as $key=>$post)
                    <tr>
                        <td>{{$key + 1}}</th>
                        <td>{{$post->title}}</td>
                        <td>{{$post->body}}</td>
                        <td>
                            <form action="{{route('post.destroy', ['post' => $post->id])}} " method="POST">
                                <a href="{{route('post.show', ['post' => $post->id])}} " class="btn btn-info ">Show</a>
                                <a href="{{route('post.edit', ['post' => $post->id])}}" class="btn btn-primary">Edit</a>
                                @csrf
                                @method('DELETE')
                                    <input type="submit" class="btn btn-danger my-1" value="Delete">
                                    {{-- <a href="{{route('post', ['post' => $post->id])}} " class="btn btn-danger ">Delete</a> --}}
                            </form>
                        </td>
                    </tr>
                @empty
                    <tr colspan="3">
                        <td></td>
                        <td>No data</td>
                    </tr>  
                @endforelse              
            </tbody>
         </table>
    </div>
</div>

@endsection

 

resources/views/post/show.blade.php
@extends('layouts.master')

@section('title')
    Show Page
@endsection

@section('content')

<div>
    <h3 style="color: blue">{{$post->title}}</h3>
    <p style="text-align: justify">{{$post->body}}</p>
    <p>
        Tags : 
        @forelse ($post->tags as $tag)
            <a href="/post" style="text-decoration: none">
                <button class="btn btn-primary btn-sm" name="post_id">{{$tag["name"]}}</button>
            </a>
        @empty
            No Tags
        @endforelse
    </p>
    {{-- <button type="submit" class="btn btn-danger">Kembali</button> --}}
    <a href="{{route('post.index')}}" class="btn btn-danger">Back</a>
</div>
@endsection